# Recolude Unity Packages

All packages associated with interfacing with different Recolude and it's different services.

## Installation

**The two packages you probably want to get started are Recolude.Core and Recolude.API** 

Make sure git is installed on your machine.

All packages available are provided under the [/src](https://gitlab.com/recolude/unity-packages/recolude/-/tree/master/src) folder within this repository. The packages available include:

* Recolude.Core - Contains fundamental functionality to creating and visualizing recordings.
* Recolude.API - Utility methods for interfacing with Recolude's REST API.
* Recolude.Analytics - Graphing functionality for the different analtics from Recolude.
* Recolude.ContentExtractor - Utility methods for extracting scene data from your Unity application

To install a package, go to Unity's package manager under `Windows > Package Manager`. Once opened, you then click the `+` button in the top left corner, and select "Add package from git URL".

![Add package from git URL](docs/images/installpackage.png)

The url you enter depends upon the package you want installed. The general url looks like:

```
https://gitlab.com/recolude/unity-packages/recolude.git?path=/src/<PACKAGE NAME>
```

So, if you wanted to install Recolude.Core, the url you'd enter would be:

```
https://gitlab.com/recolude/unity-packages/recolude.git?path=/src/Recolude.Core
```

## Examples

Example projects using the different available Recolude packages can be found under the [/examples](https://gitlab.com/recolude/unity-packages/recolude/-/tree/master/examples) folder.

## Documentation

All documentation is built from the [/docs](https://gitlab.com/recolude/unity-packages/recolude/-/tree/master/docs) folder found within this repository and is hosted on https://docs.recolude.com/.

### Building Documentation

Requires the Basic project under examples to have been loaded by Unity atleast once to generate the .csproj files.

Documentation is generated by docfx.

```bash
cd into the docs

# Build all the api definitions
docfx

# Not sure what this does but run it.
docfx build

# It does have a serve command, but it doesn't hot reload or anything
docfx serve

# There's also a pdf command, for generating pdfs
docfx pdf
```
